"""
This module is used to create the 'About' tab inside the plugin.

Author: Ioan-Matei Sarivan @ AnyBody Technology A/S
E-mail: ms@anybodytech.com

Cretaed on 19th of January, 09:06:35, 2017

"""
import wx
import pkg_resources
from bm_config import iniparse
from bm_config import res


class AboutTab(wx.Panel):
    def __init__(self, parent):
        """The About tab is created by instantiating this class."""

        wx.Panel.__init__(self, parent)

        self._iniparser = None
        self._address_text_box = None
        self._addresses = []
        self._workspaces_dropdown = None

        self._close_address_panel_button = None

        self._init_tab()

    def _init_tab(self):
        """The GUI elements inside the About tab are created"""

        self.SetBackgroundColour("WHITE")
        address = iniparse.os.path.dirname(__file__)
        address = pkg_resources.resource_filename("bm_config", "res/Images/Hello.png")
        image = wx.Image(address, wx.BITMAP_TYPE_ANY)

        maxdimension = 500
        width = image.GetWidth()
        height = image.GetHeight()

        if width > height:
            height = maxdimension * height / width
            width = maxdimension

        else:
            width = maxdimension * width / height
            height = maxdimension
        user = iniparse.os.getlogin()
        image = image.Scale(round(width), round(height))
        imageCtrl = wx.StaticBitmap(self, wx.ID_ANY, wx.Bitmap(image))
        terms = res.LICENSE_LABEL
        terms = terms.replace("<user>", user)
        label = wx.StaticText(self, label=terms)

        workspaces_sizer = wx.BoxSizer(wx.VERTICAL)
        workspaces_control_sizer = wx.BoxSizer(wx.HORIZONTAL)

        workspaces_sizer.Add(workspaces_control_sizer, 0, 0, 3)

        main_sizer = wx.BoxSizer(wx.VERTICAL)
        main_sizer.Add(imageCtrl, 0, wx.ALL | wx.ALIGN_CENTRE_HORIZONTAL, 5)

        main_sizer.Add(wx.StaticLine(self), 0, wx.TOP, 25)
        main_sizer.Add(label, 0, wx.ALIGN_CENTER_HORIZONTAL | wx.TOP, 25)

        self.SetSizer(main_sizer)

        self.GetSizer().Layout()
        self.GetParent().Layout()

        self.Show()
