# -*- coding: utf-8 -*-
"""
Author: Ioan-Matei Sarivan @ AnyBody Technology A/S
E-mail: ms@anybodytech.com

Created on Wed Sep 20 10:16:17 2017

"""

import os
import shutil
import datetime

from bm_config import res as addresses


class History:
    def __init__(self, app_data_parser, any_file):

        self._ini_file = app_data_parser
        self._any_file = any_file
        self._hist_no = None
        self._hist_dir = self._make_path(any_file)

    def _make_path(self, any_file):

        hist_number = self._ini_file.ini_read("History_No", "Current_Number")
        #print(any_file)
        if hist_number is None:
            self._ini_file.ini_edit("History_No", "Current_Number", "1")
            self._ini_file.ini_edit("History_Files", "1", any_file)
            self._ini_file.ini_edit("History_Codes", any_file, "1")
            if not os.path.isdir(addresses.history_dir + "1"):
                os.makedirs(addresses.history_dir + "1")
            #print(1)
            if not os.path.exists(addresses.last_configuration + "1.any"):
                if not os.path.isdir(addresses.last_configuration):
                    os.makedirs(addresses.last_configuration)
                shutil.copy2(any_file, addresses.last_configuration + "1.any")
            return addresses.history_dir + "1"
        elif not self._ini_file.check_section_keys("History_Codes", any_file):
            hist_no = int(hist_number) + 1
            hist_no = str(hist_no)
            self._ini_file.ini_edit("History_No", "Current_Number", hist_no)
            self._ini_file.ini_edit("History_Files", hist_no, any_file)
            self._ini_file.ini_edit("History_Codes", any_file, hist_no)
            if not os.path.isdir(addresses.history_dir + hist_no):
                os.makedirs(addresses.history_dir + hist_no)
            #print(2)
            if not os.path.exists(addresses.last_configuration + hist_no + ".any"):
                if not os.path.isdir(addresses.last_configuration):
                    os.makedirs(addresses.last_configuration)
                shutil.copy2(any_file, addresses.last_configuration + hist_no + ".any")
            self._hist_no = hist_no
            return addresses.history_dir + hist_no
        else:
            hist_no = self._ini_file.ini_read("History_Codes", any_file)
            #print(hist_no)
            if not os.path.isdir(addresses.history_dir + hist_no):
                os.makedirs(addresses.history_dir + hist_no)
            #print(3)
            if not os.path.exists(addresses.last_configuration + hist_no + ".any"):
                if not os.path.isdir(addresses.last_configuration):
                    os.makedirs(addresses.last_configuration)
                shutil.copy2(any_file, addresses.last_configuration + hist_no + ".any")
            self._hist_no = hist_no
            return addresses.history_dir + hist_no

    def save_last_ok_load(self):
        if self._hist_no is None:
            self._hist_no = "1"
        shutil.copy2(
            self._any_file, addresses.last_configuration + self._hist_no + ".any"
        )

    def get_last_ok_load(self):
        if self._hist_no is None:
            self._hist_no = "1"
        shutil.copy2(
            addresses.last_configuration + self._hist_no + ".any", self._any_file
        )

    def get_history_list(self):
        return os.listdir(self._hist_dir)

    def make_history_file_path(self):

        now = datetime.datetime.now()
        now = now.strftime("%Y-%m-%d %H-%M-%S")
        shutil.copyfile(self._any_file, self._hist_dir + "\\" + str(now) + ".any")
        files = os.listdir(self._hist_dir)
        first = True
        for file in files:
            ctime = os.path.getctime(self._hist_dir + "\\" + file)
            if first:
                oldest = file
                first = False
            elif ctime < os.path.getctime(self._hist_dir + "\\" + oldest):
                oldest = file
        if len(files) > 10:
            os.remove(self._hist_dir + "\\" + oldest)
            #print(oldest)

    def apply_history_file(self, file):
        shutil.copyfile(self._hist_dir + "\\" + file + ".any", self._any_file)
