# -*- coding: utf-8 -*-
"""
Author: Ioan-Matei Sarivan @ AnyBody Technology A/S
E-mail: ms@anybodytech.com

Created on Tue Sep  5 16:07:33 2017

"""

import wx


class Image:
    def __init__(self, parent, img_address, maxdimension):
        image = wx.Image(img_address, wx.BITMAP_TYPE_ANY)

        width = image.GetWidth()
        height = image.GetHeight()

        if width > height:
            height = maxdimension * height / width
            width = maxdimension

        else:
            width = maxdimension * width / height
            height = maxdimension

        image = image.Scale(round(width), round(height))
        self._imageCtrl = wx.StaticBitmap(parent, wx.ID_ANY, wx.Bitmap(image))

    def get_image_ctrl(self):
        return self._imageCtrl
