# -*- coding: utf-8 -*-
"""
Author: Ioan-Matei Sarivan @ AnyBody Technology A/S
E-mail: ms@anybodytech.com

Created on Tue May 22 13:38:18 2018

"""

import os
import time
import shutil

from bm_config import res


class Memento:
    def __init__(self, address):
        self._undo = []
        self._redo = []
        self._file_path = address
        self._undo_stack_folder = res.appdata_address + "\\UNDO_STACK"

        if not os.path.exists(self._undo_stack_folder):
            os.mkdir(self._undo_stack_folder)
        for file in os.listdir(self._undo_stack_folder):
            os.remove(self._undo_stack_folder + "\\" + file)
        name = str(int(time.time() * 10000)) + ".0"
        shutil.copy(self._file_path, self._undo_stack_folder + "\\" + name)
        self._current_memento = name

    def create_memento(self, tab):
        print(tab)
        name = str(int(time.time() * 10000)) + "." + str(tab)
        shutil.copy(self._file_path, self._undo_stack_folder + "\\" + name)
        self._undo.append(self._current_memento)
        self._current_memento = name
        for file in self._redo:
            os.remove(self._undo_stack_folder + "\\" + file)
        self._redo.clear()
        print("undo", self._undo)
        print("redo", self._redo)

    def get_memento(self):
        self._redo.append(self._current_memento)
        _, tab = self._current_memento.split(".")
        memento = self._undo.pop()
        shutil.copy(self._undo_stack_folder + "\\" + memento, self._file_path)
        self._current_memento = memento
        file, tab = memento.split(".")
        print("undo", self._undo)
        print("redo", self._redo)
        print(len(self._redo))
        if len(self._undo):
            return tab
        else:
            return False

    def get_stack(self):
        return len(self._undo), len(self._redo)

    def set_memento(self):
        self._undo.append(self._current_memento)
        _, tab = self._current_memento.split(".")
        memento = self._redo.pop()
        shutil.copy(self._undo_stack_folder + "\\" + memento, self._file_path)
        self._current_memento = memento
        file, tab = memento.split(".")
        print("undo", self._undo)
        print("redo", self._redo)
        return tab
