# -*- coding: utf-8 -*-
"""
Author: Ioan-Matei Sarivan @ AnyBody Technology A/S
E-mail: ms@anybodytech.com

Created on Wed Sep 20 11:09:31 2017

"""

import os
import pkg_resources

file_address = os.path.dirname(__file__)
appdata_address = os.getenv("APPDATA") + "\\AnyBody Technology\\Plugins\\BM_Plugin"
icon_address = pkg_resources.resource_filename("bm_config", "res/Images/BMConfig.ico")
bm_param_address = pkg_resources.resource_filename(
    "bm_config", "res/bm-param/bm-parameters.toml"
)
default_any_address = pkg_resources.resource_filename(
    "bm_config", "res/ANY/BodyModelConfiguration.any"
)
history_dir = appdata_address + "\\LOGS\\"
last_configuration = appdata_address + "\\LASTOK\\"

# __init__.py
DESCRIPTION = 'When using arguments, the plugin goes in the "connected" mode, establishing the communication with AnyBody by having the port number, the plugin id and the .any file to be modified.'
PORT_HELP = "Port number for connecting the plugin to"
ID_HELP = "Identification number of the plugin"
APP_TITLE = "Body Model Configurator"
WARN_TITLE = "Missing dependencies!"
WARN_TEXT = 'There are missing python dependencies!\nTo install the dependencies needed for the Body Model Configurator Plugin,\nrun the "conda install -c anybody anybody_python" command inside an Anaconda terminal.'

# BM_Plugin.py
NO_IN_FILE_TEXT = "No script file for BM statements found.\nDo you want BM-Plugin to create it and include it in the main.any file for you?\nIf yes, BM-Plugin will save the loaded main.any file for you."
NO_IN_FILE_TITLE = "No script file"
NO_HUMAN = "Your main script file appears to not contain an include of a HumanModel.any file!\nYou might however have this include in another sub file, but you have to manually specify which file is it.\nDo you wish to proceed with using the plugin?"
HUMAN_FILE = "HumanModel.any"
INCLUDE = "#include"
BM_PARAM_FILE = "bm-parameters.toml"
DEFAULT_ANY_FILE = "BodyModelConfiguration.any"
DEFAULT_ANY_PATH = "Application\\Examples\\StandingModel\\Model\\"
IN_FILE = "BodyModelConfiguration.any"
ADRS_TAB = "Script File"
ABOUT_TAB = "About"
ADV_TAB = "Advanced"
DRIVERS_TAB = "Mannequin Drivers"
TRUNK_TAB = "Trunk"
ARMS_TAB = "Arms"
LEGS_TAB = "Legs"
BODY_TAB = "Body"
BL_DEFAULT = "Restore Default Values"
L_HISTORY = "Apply History:"
BL_LOAD = "Apply"
OKSTAT = "Status: OK"
ERRSTAT = "Status: Error"
PROMPTANY = "Choose an .any file to modify..."
WARN_CLOSED = "AMS was closed, not running, or no main file is loaded!\n The plugin will now close."
WARN_FAILED = "The configuration yielded a failed model load!\nThe Plugin will undo the last change and try to load again the model.\nDo you want to proceed?"
ERRTYPOS = "There are typos or duplicates in the .any file: "
ERRDUB = "There are duplicates in the .any file: "
DEFAULT = "Try restore defaults."
PROMPTCONF = "Configure your body model... "
LOADSTAT = "Status: Loading"
LOADING = "The plugin is loading tabs. Please wait."
MODELFAIL = "Failed to load model. Try undo changes."

# address_tab.py
L_DO_TEXT = "The plug-in is running in stand-alone mode"
L_ADDRESS = "Enter the address or browse for the AnyBody workspace directory:"
L_TEXT = "Choose the .any file containing BM statements to be modified"
DIALOG = "Pick the .any file you want to modify"
WARNING = 'An address for the .any file you want to modify was not specified!\nClick "Browse" and select the .any file you want to modify.'

# advtab.py
ADV_DESCRIPTION = "Select parameter to be described"
NO_DESCR = "Option has no description"

# abouttab.py
LICENSE_LABEL = 'Software Name: BodyModel Configurator Plugin\nSoftware Type: Plugin\nVersion: Beta\n \nLicensed to: <user>\n \nLicense Certificate: \nUse of this source code and material is covered by the\nAnyBody Technology A/S Software License Agreement\nunder the same terms as the "AnyBody Managed Model Repository"\n(AMMR) stated in the Agreement.\n \nSee: https://www.anybodytech.com/legal/software-license-agreement/\n \nCopyright(C) 1999-2018, AnyBody Technology A/S. All rights reserved.\n'
